import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Properties;

import javax.swing.JFrame;
import javax.swing.JPanel;

/**
 * A loader for the client applet.
 * @author Apache Ah64
 */
public class RS2Loader extends Applet {

	/**
	 * The internet protocol address.
	 */
	public static final String IP_ADDRESS = "127.0.0.1";

	/**
	 * The port.
	 */
	public static final int PORT = 43594;

	/**
	 * The revision.
	 */
	public static final int REVISION = 1;

	/**
	 * If we want to connect to RuneScape.
	 */
	public static final boolean RUNESCAPE = false;

	/**
	 * The properties.
	 */
	private static final Properties PARAMETERS = new Properties();

	/**
	 * The client reference.
	 */
	private static client c;

	/**
	 * The main method.
	 * @param args The arguments.
	 */
	public static void main(String[] args) {
		new RS2Loader().open();
	}

	/**
	 * Open the client in a frame.
	 */
	private void open() {
		JFrame frame = new JFrame("Matrix - The most advanced RSPS!");
		frame.setLayout(new BorderLayout());
		final JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(c = new client());
		c.init();
		c.start();
		panel.setPreferredSize(new Dimension(765, 503));
		frame.getContentPane().add(panel, "Center");
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		final Dimension dimensions = Toolkit.getDefaultToolkit().getScreenSize();
		frame.setLocation((int) ((dimensions.getWidth() - frame.getWidth()) / 2), (int) ((dimensions.getHeight() - frame.getHeight()) / 2));
		frame.setVisible(true);
	}

	/**
	 * Get a parameter from either our preset properties or the client instance.
	 * @param key The key.
	 * @return The parameter.
	 */
	@Override
	public String getParameter(String key) {
		if(PARAMETERS.containsKey(key)) {
			return PARAMETERS.getProperty(key);
		}
		return c.getParameter(key);
	}

	@Override
	public URL getDocumentBase() {
		return this.getCodeBase();
	}

	@Override
	public URL getCodeBase() {
		try {
			return new URL("http://" + IP_ADDRESS);
		} catch (MalformedURLException e) {
			e.printStackTrace();
		}
		return null;
	}

	static {
		PARAMETERS.put("boxbgcolor", "black");
		PARAMETERS.put("boxborder", "false");
		PARAMETERS.put("image", "http://www.runescape.com/img/rsp777/oldschool_ani.gif");
		PARAMETERS.put("centerimage", "true");
		PARAMETERS.put("java_arguments", "-Xmx256m -Xss2m -Dsun.java2d.noddraw=true -XX:CompileThreshold=1500 -Xincgc -XX:+UseConcMarkSweepGC -XX:+UseParNewGC");
		PARAMETERS.put("separate_jvm", "true");
		PARAMETERS.put("1", "true");
		PARAMETERS.put("7", "0");
		PARAMETERS.put("5", "0");
		PARAMETERS.put("3", "true");
		PARAMETERS.put("2", "301");
		PARAMETERS.put("9", "http://www.runescape.com/slr.ws?order=LPWM");
		PARAMETERS.put("4", "0");
		PARAMETERS.put("8", "5");
		PARAMETERS.put("6", "true");
		PARAMETERS.put("haveie6", "true");
	}

}
